/* Generated by re2c 3.1 */
#line 1 "ext/date/lib/parse_iso_intervals.re"
/*
 * The MIT License (MIT)
 *
 * Copyright (c) 2015-2019 Derick Rethans
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#include "timelib.h"
#include "timelib_private.h"

#include <ctype.h>

#if defined(_MSC_VER)
# define strtoll(s, f, b) _atoi64(s)
#elif !defined(HAVE_STRTOLL)
# if defined(HAVE_ATOLL)
#  define strtoll(s, f, b) atoll(s)
# else
#  define strtoll(s, f, b) strtol(s, f, b)
# endif
#endif

#define EOI      257

#define TIMELIB_PERIOD  260
#define TIMELIB_ISO_DATE 261
#define TIMELIB_ERROR   999

typedef unsigned char uchar;

#define   BSIZE	   8192

#define   YYCTYPE      uchar
#define   YYCURSOR     cursor
#define   YYLIMIT      s->lim
#define   YYMARKER     s->ptr
#define   YYFILL(n)    return EOI;

#define   RET(i)       {s->cur = cursor; return i;}

#define timelib_string_free timelib_free

#define TIMELIB_INIT  s->cur = cursor; str = timelib_string(s); ptr = str
#define TIMELIB_DEINIT timelib_string_free(str)

#ifdef DEBUG_PARSER
#define DEBUG_OUTPUT(s) printf("%s\n", s);
#define YYDEBUG(s,c) { if (s != -1) { printf("state: %d ", s); printf("[%c]\n", c); } }
#else
#define DEBUG_OUTPUT(s)
#define YYDEBUG(s,c)
#endif

typedef struct _Scanner {
	int           fd;
	uchar        *lim, *str, *ptr, *cur, *tok, *pos;
	unsigned int  line, len;
	timelib_error_container *errors;

	timelib_time     *begin;
	timelib_time     *end;
	timelib_rel_time *period;
	int               recurrences;

	int have_period;
	int have_recurrences;
	int have_date;
	int have_begin_date;
	int have_end_date;
} Scanner;

static void add_error(Scanner *s, const char *error)
{
	s->errors->error_count++;
	s->errors->error_messages = timelib_realloc(s->errors->error_messages, s->errors->error_count * sizeof(timelib_error_message));
	s->errors->error_messages[s->errors->error_count - 1].position = s->tok ? s->tok - s->str : 0;
	s->errors->error_messages[s->errors->error_count - 1].character = s->tok ? *s->tok : 0;
	s->errors->error_messages[s->errors->error_count - 1].message = timelib_strdup(error);
}

static char *timelib_string(Scanner *s)
{
	char *tmp = timelib_calloc(1, s->cur - s->tok + 1);
	memcpy(tmp, s->tok, s->cur - s->tok);

	return tmp;
}

static timelib_sll timelib_get_nr(const char **ptr, int max_length)
{
	const char *begin, *end;
	char *str;
	timelib_sll tmp_nr = TIMELIB_UNSET;
	int len = 0;

	while ((**ptr < '0') || (**ptr > '9')) {
		if (**ptr == '\0') {
			return TIMELIB_UNSET;
		}
		++*ptr;
	}
	begin = *ptr;
	while ((**ptr >= '0') && (**ptr <= '9') && len < max_length) {
		++*ptr;
		++len;
	}
	end = *ptr;
	str = timelib_calloc(1, end - begin + 1);
	memcpy(str, begin, end - begin);
	tmp_nr = strtoll(str, NULL, 10);
	timelib_free(str);
	return tmp_nr;
}

static timelib_ull timelib_get_unsigned_nr(const char **ptr, int max_length)
{
	timelib_ull dir = 1;

	while (((**ptr < '0') || (**ptr > '9')) && (**ptr != '+') && (**ptr != '-')) {
		if (**ptr == '\0') {
			return TIMELIB_UNSET;
		}
		++*ptr;
	}

	while (**ptr == '+' || **ptr == '-')
	{
		if (**ptr == '-') {
			dir *= -1;
		}
		++*ptr;
	}
	return dir * timelib_get_nr(ptr, max_length);
}

#define timelib_split_free(arg) {       \
	int i;                         \
	for (i = 0; i < arg.c; i++) {  \
		timelib_free(arg.v[i]);    \
	}                              \
	if (arg.v) {                   \
		timelib_free(arg.v);       \
	}                              \
}

/* date parser's scan function too large for VC6 - VC7.x
   drop the optimization solves the problem */
#ifdef PHP_WIN32
#pragma optimize( "", off )
#endif
static int scan(Scanner *s)
{
	uchar *cursor = s->cur;
	char *str;
	const char *ptr = NULL;

std:
	s->tok = cursor;
	s->len = 0;
#line 204 "ext/date/lib/parse_iso_intervals.re"



#line 184 "ext/date/lib/parse_iso_intervals.c"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	static const unsigned char yybm[] = {
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
	};
	if ((YYLIMIT - YYCURSOR) < 20) YYFILL(20);
	yych = *YYCURSOR;
	if (yych <= ',') {
		if (yych <= '\n') {
			if (yych <= 0x00) goto yy1;
			if (yych <= 0x08) goto yy2;
			if (yych <= '\t') goto yy4;
		} else {
			if (yych == ' ') goto yy4;
			if (yych <= '+') goto yy2;
			goto yy4;
		}
	} else {
		if (yych <= 'O') {
			if (yych <= '-') goto yy2;
			if (yych <= '/') goto yy4;
			if (yych <= '9') goto yy5;
			goto yy2;
		} else {
			if (yych <= 'P') goto yy6;
			if (yych == 'R') goto yy8;
			goto yy2;
		}
	}
yy1:
	++YYCURSOR;
#line 311 "ext/date/lib/parse_iso_intervals.re"
	{
		s->pos = cursor; s->line++;
		goto std;
	}
#line 253 "ext/date/lib/parse_iso_intervals.c"
yy2:
	++YYCURSOR;
yy3:
#line 317 "ext/date/lib/parse_iso_intervals.re"
	{
		add_error(s, "Unexpected character");
		goto std;
	}
#line 262 "ext/date/lib/parse_iso_intervals.c"
yy4:
	++YYCURSOR;
#line 306 "ext/date/lib/parse_iso_intervals.re"
	{
		goto std;
	}
#line 269 "ext/date/lib/parse_iso_intervals.c"
yy5:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') goto yy3;
	if (yych <= '9') goto yy9;
	goto yy3;
yy6:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') goto yy7;
	if (yych <= '9') goto yy11;
	if (yych == 'T') goto yy12;
yy7:
#line 244 "ext/date/lib/parse_iso_intervals.re"
	{
		timelib_sll nr;
		int         in_time = 0;
		DEBUG_OUTPUT("period");
		TIMELIB_INIT;
		ptr++;
		do {
			if ( *ptr == 'T' ) {
				in_time = 1;
				ptr++;
			}
			if ( *ptr == '\0' ) {
				add_error(s, "Missing expected time part");
				break;
			}

			nr = timelib_get_unsigned_nr(&ptr, 12);
			switch (*ptr) {
				case 'Y': s->period->y = nr; break;
				case 'W': s->period->d += nr * 7; break;
				case 'D': s->period->d += nr; break;
				case 'H': s->period->h = nr; break;
				case 'S': s->period->s = nr; break;
				case 'M':
					if (in_time) {
						s->period->i = nr;
					} else {
						s->period->m = nr;
					}
					break;
				default:
					add_error(s, "Undefined period specifier");
					break;
			}
			ptr++;
		} while (!s->errors->error_count && *ptr);
		s->have_period = 1;
		TIMELIB_DEINIT;
		return TIMELIB_PERIOD;
	}
#line 324 "ext/date/lib/parse_iso_intervals.c"
yy8:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 128) {
		goto yy13;
	}
	goto yy3;
yy9:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '9') goto yy14;
yy10:
	YYCURSOR = YYMARKER;
	if (yyaccept == 0) {
		goto yy3;
	} else {
		goto yy7;
	}
yy11:
	yych = *++YYCURSOR;
	if (yych <= 'L') {
		if (yych <= '9') {
			if (yych <= '/') goto yy10;
			goto yy15;
		} else {
			if (yych == 'D') goto yy16;
			goto yy10;
		}
	} else {
		if (yych <= 'W') {
			if (yych <= 'M') goto yy17;
			if (yych <= 'V') goto yy10;
			goto yy18;
		} else {
			if (yych == 'Y') goto yy19;
			goto yy10;
		}
	}
yy12:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') goto yy7;
	if (yych <= '9') goto yy20;
	goto yy7;
yy13:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 128) {
		goto yy13;
	}
#line 209 "ext/date/lib/parse_iso_intervals.re"
	{
		DEBUG_OUTPUT("recurrences");
		TIMELIB_INIT;
		ptr++;
		s->recurrences = timelib_get_unsigned_nr(&ptr, 9);
		TIMELIB_DEINIT;
		s->have_recurrences = 1;
		return TIMELIB_PERIOD;
	}
#line 385 "ext/date/lib/parse_iso_intervals.c"
yy14:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '9') goto yy21;
	goto yy10;
yy15:
	yych = *++YYCURSOR;
	if (yych <= 'L') {
		if (yych <= '9') {
			if (yych <= '/') goto yy10;
			goto yy22;
		} else {
			if (yych != 'D') goto yy10;
		}
	} else {
		if (yych <= 'W') {
			if (yych <= 'M') goto yy17;
			if (yych <= 'V') goto yy10;
			goto yy18;
		} else {
			if (yych == 'Y') goto yy19;
			goto yy10;
		}
	}
yy16:
	yych = *++YYCURSOR;
	if (yych == 'T') goto yy12;
	goto yy7;
yy17:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') goto yy7;
	if (yych <= '9') goto yy23;
	if (yych == 'T') goto yy12;
	goto yy7;
yy18:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') goto yy7;
	if (yych <= '9') goto yy24;
	if (yych == 'T') goto yy12;
	goto yy7;
yy19:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') goto yy7;
	if (yych <= '9') goto yy25;
	if (yych == 'T') goto yy12;
	goto yy7;
yy20:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 'H') {
		if (yych <= '/') goto yy10;
		if (yych <= '9') goto yy20;
		if (yych <= 'G') goto yy10;
		goto yy26;
	} else {
		if (yych <= 'M') {
			if (yych <= 'L') goto yy10;
			goto yy27;
		} else {
			if (yych == 'S') goto yy28;
			goto yy10;
		}
	}
yy21:
	yych = *++YYCURSOR;
	if (yych <= '/') {
		if (yych == '-') goto yy29;
		goto yy10;
	} else {
		if (yych <= '0') goto yy30;
		if (yych <= '1') goto yy31;
		goto yy10;
	}
yy22:
	yych = *++YYCURSOR;
	if (yych <= 'L') {
		if (yych <= '9') {
			if (yych <= '/') goto yy10;
			goto yy32;
		} else {
			if (yych == 'D') goto yy16;
			goto yy10;
		}
	} else {
		if (yych <= 'W') {
			if (yych <= 'M') goto yy17;
			if (yych <= 'V') goto yy10;
			goto yy18;
		} else {
			if (yych == 'Y') goto yy19;
			goto yy10;
		}
	}
yy23:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'C') {
		if (yych <= '/') goto yy10;
		if (yych <= '9') goto yy23;
		goto yy10;
	} else {
		if (yych <= 'D') goto yy16;
		if (yych == 'W') goto yy18;
		goto yy10;
	}
yy24:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '9') goto yy24;
	if (yych == 'D') goto yy16;
	goto yy10;
yy25:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'D') {
		if (yych <= '/') goto yy10;
		if (yych <= '9') goto yy25;
		if (yych <= 'C') goto yy10;
		goto yy16;
	} else {
		if (yych <= 'M') {
			if (yych <= 'L') goto yy10;
			goto yy17;
		} else {
			if (yych == 'W') goto yy18;
			goto yy10;
		}
	}
yy26:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') goto yy7;
	if (yych <= '9') goto yy33;
	goto yy7;
yy27:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') goto yy7;
	if (yych <= '9') goto yy34;
	goto yy7;
yy28:
	++YYCURSOR;
	goto yy7;
yy29:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '0') goto yy35;
	if (yych <= '1') goto yy36;
	goto yy10;
yy30:
	yych = *++YYCURSOR;
	if (yych <= '0') goto yy10;
	if (yych <= '9') goto yy37;
	goto yy10;
yy31:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '2') goto yy37;
	goto yy10;
yy32:
	yych = *++YYCURSOR;
	if (yych == '-') goto yy38;
	goto yy40;
yy33:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 'L') {
		if (yych <= '/') goto yy10;
		if (yych <= '9') goto yy33;
		goto yy10;
	} else {
		if (yych <= 'M') goto yy27;
		if (yych == 'S') goto yy28;
		goto yy10;
	}
yy34:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '9') goto yy34;
	if (yych == 'S') goto yy28;
	goto yy10;
yy35:
	yych = *++YYCURSOR;
	if (yych <= '0') goto yy10;
	if (yych <= '9') goto yy41;
	goto yy10;
yy36:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '2') goto yy41;
	goto yy10;
yy37:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '0') goto yy42;
	if (yych <= '2') goto yy43;
	if (yych <= '3') goto yy44;
	goto yy10;
yy38:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '0') goto yy45;
	if (yych <= '1') goto yy46;
	goto yy10;
yy39:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
yy40:
	if (yych <= 'L') {
		if (yych <= '9') {
			if (yych <= '/') goto yy10;
			goto yy39;
		} else {
			if (yych == 'D') goto yy16;
			goto yy10;
		}
	} else {
		if (yych <= 'W') {
			if (yych <= 'M') goto yy17;
			if (yych <= 'V') goto yy10;
			goto yy18;
		} else {
			if (yych == 'Y') goto yy19;
			goto yy10;
		}
	}
yy41:
	yych = *++YYCURSOR;
	if (yych == '-') goto yy47;
	goto yy10;
yy42:
	yych = *++YYCURSOR;
	if (yych <= '0') goto yy10;
	if (yych <= '9') goto yy48;
	goto yy10;
yy43:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '9') goto yy48;
	goto yy10;
yy44:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '1') goto yy48;
	goto yy10;
yy45:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '9') goto yy49;
	goto yy10;
yy46:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '2') goto yy49;
	goto yy10;
yy47:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '0') goto yy50;
	if (yych <= '2') goto yy51;
	if (yych <= '3') goto yy52;
	goto yy10;
yy48:
	yych = *++YYCURSOR;
	if (yych == 'T') goto yy53;
	goto yy10;
yy49:
	yych = *++YYCURSOR;
	if (yych == '-') goto yy54;
	goto yy10;
yy50:
	yych = *++YYCURSOR;
	if (yych <= '0') goto yy10;
	if (yych <= '9') goto yy55;
	goto yy10;
yy51:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '9') goto yy55;
	goto yy10;
yy52:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '1') goto yy55;
	goto yy10;
yy53:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '1') goto yy56;
	if (yych <= '2') goto yy57;
	goto yy10;
yy54:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '2') goto yy58;
	if (yych <= '3') goto yy59;
	goto yy10;
yy55:
	yych = *++YYCURSOR;
	if (yych == 'T') goto yy60;
	goto yy10;
yy56:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '9') goto yy61;
	goto yy10;
yy57:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '4') goto yy61;
	goto yy10;
yy58:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '9') goto yy62;
	goto yy10;
yy59:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '1') goto yy62;
	goto yy10;
yy60:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '1') goto yy63;
	if (yych <= '2') goto yy64;
	goto yy10;
yy61:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '5') goto yy65;
	goto yy10;
yy62:
	yych = *++YYCURSOR;
	if (yych == 'T') goto yy66;
	goto yy10;
yy63:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '9') goto yy67;
	goto yy10;
yy64:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '4') goto yy67;
	goto yy10;
yy65:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '9') goto yy68;
	goto yy10;
yy66:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '1') goto yy69;
	if (yych <= '2') goto yy70;
	goto yy10;
yy67:
	yych = *++YYCURSOR;
	if (yych == ':') goto yy71;
	goto yy10;
yy68:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '5') goto yy72;
	goto yy10;
yy69:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '9') goto yy73;
	goto yy10;
yy70:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '4') goto yy73;
	goto yy10;
yy71:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '5') goto yy74;
	goto yy10;
yy72:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '9') goto yy75;
	goto yy10;
yy73:
	yych = *++YYCURSOR;
	if (yych == ':') goto yy76;
	goto yy10;
yy74:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '9') goto yy77;
	goto yy10;
yy75:
	yych = *++YYCURSOR;
	if (yych == 'Z') goto yy78;
	goto yy10;
yy76:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych <= '5') goto yy79;
	goto yy10;
yy77:
	yych = *++YYCURSOR;
	if (yych == ':') goto yy68;
	goto yy10;
yy78:
	++YYCURSOR;
#line 220 "ext/date/lib/parse_iso_intervals.re"
	{
		timelib_time *current;

		if (s->have_date || s->have_period) {
			current = s->end;
			s->have_end_date = 1;
		} else {
			current = s->begin;
			s->have_begin_date = 1;
		}
		DEBUG_OUTPUT("datetimebasic | datetimeextended");
		TIMELIB_INIT;
		current->y = timelib_get_nr(&ptr, 4);
		current->m = timelib_get_nr(&ptr, 2);
		current->d = timelib_get_nr(&ptr, 2);
		current->h = timelib_get_nr(&ptr, 2);
		current->i = timelib_get_nr(&ptr, 2);
		current->s = timelib_get_nr(&ptr, 2);
		s->have_date = 1;
		TIMELIB_DEINIT;
		return TIMELIB_ISO_DATE;
	}
#line 831 "ext/date/lib/parse_iso_intervals.c"
yy79:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych >= ':') goto yy10;
	yych = *++YYCURSOR;
	if (yych != ':') goto yy10;
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych >= '6') goto yy10;
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy10;
	if (yych >= ':') goto yy10;
	++YYCURSOR;
#line 286 "ext/date/lib/parse_iso_intervals.re"
	{
		DEBUG_OUTPUT("combinedrep");
		TIMELIB_INIT;
		s->period->y = timelib_get_unsigned_nr(&ptr, 4);
		ptr++;
		s->period->m = timelib_get_unsigned_nr(&ptr, 2);
		ptr++;
		s->period->d = timelib_get_unsigned_nr(&ptr, 2);
		ptr++;
		s->period->h = timelib_get_unsigned_nr(&ptr, 2);
		ptr++;
		s->period->i = timelib_get_unsigned_nr(&ptr, 2);
		ptr++;
		s->period->s = timelib_get_unsigned_nr(&ptr, 2);
		s->have_period = 1;
		TIMELIB_DEINIT;
		return TIMELIB_PERIOD;
	}
#line 864 "ext/date/lib/parse_iso_intervals.c"
}
#line 321 "ext/date/lib/parse_iso_intervals.re"

}
#ifdef PHP_WIN32
#pragma optimize( "", on )
#endif

#line 873 "ext/date/lib/parse_iso_intervals.c"
#define YYMAXFILL 20
#line 327 "ext/date/lib/parse_iso_intervals.re"


void timelib_strtointerval(const char *s, size_t len,
                           timelib_time **begin, timelib_time **end,
						   timelib_rel_time **period, int *recurrences,
						   timelib_error_container **errors)
{
	Scanner in;
	int t;
	const char *e = s + len - 1;

	memset(&in, 0, sizeof(in));
	in.errors = timelib_malloc(sizeof(timelib_error_container));
	in.errors->warning_count = 0;
	in.errors->warning_messages = NULL;
	in.errors->error_count = 0;
	in.errors->error_messages = NULL;

	if (len > 0) {
		while (isspace(*s) && s < e) {
			s++;
		}
		while (isspace(*e) && e > s) {
			e--;
		}
	}
	if (e - s < 0) {
		add_error(&in, "Empty string");
		if (errors) {
			*errors = in.errors;
		} else {
			timelib_error_container_dtor(in.errors);
		}
		return;
	}
	e++;

	/* init cursor */
	in.str = timelib_malloc((e - s) + YYMAXFILL);
	memset(in.str, 0, (e - s) + YYMAXFILL);
	memcpy(in.str, s, (e - s));
	in.lim = in.str + (e - s) + YYMAXFILL;
	in.cur = in.str;

	/* init value containers */
	in.begin = timelib_time_ctor();
	in.begin->y = TIMELIB_UNSET;
	in.begin->d = TIMELIB_UNSET;
	in.begin->m = TIMELIB_UNSET;
	in.begin->h = TIMELIB_UNSET;
	in.begin->i = TIMELIB_UNSET;
	in.begin->s = TIMELIB_UNSET;
	in.begin->us = 0;
	in.begin->z = 0;
	in.begin->dst = 0;
	in.begin->is_localtime = 0;
	in.begin->zone_type = TIMELIB_ZONETYPE_OFFSET;

	in.end = timelib_time_ctor();
	in.end->y = TIMELIB_UNSET;
	in.end->d = TIMELIB_UNSET;
	in.end->m = TIMELIB_UNSET;
	in.end->h = TIMELIB_UNSET;
	in.end->i = TIMELIB_UNSET;
	in.end->s = TIMELIB_UNSET;
	in.end->us = 0;
	in.end->z = 0;
	in.end->dst = 0;
	in.end->is_localtime = 0;
	in.end->zone_type = TIMELIB_ZONETYPE_OFFSET;

	in.period = timelib_rel_time_ctor();
	in.period->y = 0;
	in.period->d = 0;
	in.period->m = 0;
	in.period->h = 0;
	in.period->i = 0;
	in.period->s = 0;
	in.period->weekday = 0;
	in.period->weekday_behavior = 0;
	in.period->first_last_day_of = 0;
	in.period->days = TIMELIB_UNSET;

	in.recurrences = 1;

	do {
		t = scan(&in);
#ifdef DEBUG_PARSER
		printf("%d\n", t);
#endif
	} while(t != EOI);

	timelib_free(in.str);
	if (errors) {
		*errors = in.errors;
	} else {
		timelib_error_container_dtor(in.errors);
	}
	if (in.have_begin_date) {
		*begin = in.begin;
	} else {
		timelib_time_dtor(in.begin);
	}
	if (in.have_end_date) {
		*end   = in.end;
	} else {
		timelib_time_dtor(in.end);
	}
	if (in.have_period) {
		*period = in.period;
	} else {
		timelib_rel_time_dtor(in.period);
	}
	if (in.have_recurrences) {
		*recurrences = in.recurrences;
	}
}


/*
 * vim: syntax=c
 */
